﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=7.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public Wifiastream As AsyncStreams
	Private Wifisocket As Socket
	Public Wificonnected As Boolean
	Private Wifiwatchdog As Timer
	Private WifilastValueTime As Long
	Private WifiBuffer() As Byte
	Dim Inbuf(17) As Byte
	Dim inbufact As Byte
	Dim Ident As Int
	Dim value As Int
	Dim wehebbeneaangelogd As Boolean
End Sub

Sub Service_Create
	Wifiwatchdog.Initialize("watchdog", 1000)
	inbufact = 0
End Sub


Public Sub Connect(ip As String) 
	If Wifiastream.IsInitialized Then
		Wifiastream.Close
	End If
	Wifisocket.Initialize("socket")
	Wifisocket.Connect(ip, 51042, 0)''30000)
''	Return Wifisocket.Connected 
End Sub
Private Sub Disconnect
	If Wifiastream.IsInitialized Then
		Wifiastream.Close
	End If
	Log("Disconnected")
	Wificonnected = False
	Wifiwatchdog.Enabled = False
	
End Sub


Private Sub Socket_Connected (Successful As Boolean)
	If Successful Then
		Wificonnected = True
		If Wifiastream.IsInitialized = False Then
			Wifiastream.InitializePrefix(Wifisocket.InputStream, False, Wifisocket.OutputStream, "Wifiastream")
		End If
''		CallSub(Main, "WifiStateChanged")
		Wifiwatchdog.Enabled = True
		WifilastValueTime = DateTime.Now	
		If wehebbeneaangelogd = True Then
			Log("we gaan sturen1")
			Wifiastream.Write(WifiBuffer)
		End If
		Sleep(100)
''		Wifiastream.Write(WifiBuffer)
	End If
End Sub

Public Sub WifiSendBuffer (Buffer() As Byte)
	 WifiBuffer = Buffer
	Log("Wifisendbuffer")
	If Wificonnected = False Then
		wehebbeneaangelogd = True
	Dim i As Int = 0
	Do While Wificonnected = False
		i=i+1
		If i>20 Then Exit
		CallSub2("","Connect", General.WifiIpAdress)
		Sleep(0)
		Sleep(2)
	Loop
Else
	wehebbeneaangelogd = False
	Log("we gaan sturen")
		Wifiastream.Write(WifiBuffer)
End If
End Sub

Private Sub Wifiastream_NewData (Buffer() As Byte) 
	Log(BytesToString(Buffer, 0, Buffer.Length, "UTF8"))
	Dim  bufferSize As Int
	bufferSize = 7
	If Buffer.Length> 17 Then Return
	For i=0 To Buffer.Length-1
		Inbuf(inbufact) = Buffer(i)
		inbufact = inbufact +1
	Next
	
	If inbufact >=bufferSize Then							''If the buffer is the correct size or bigger 
															'' if bigger we should actually take the first one of the buffer and recheck
		If Inbuf(0) = -1 Then								'' and starts with 255, 255, 255
			If Inbuf(1) = -1 Then
				If Inbuf(2) = -1 Then
					Dim ffbyte As Byte
					Ident = General.ToUnsigned(Inbuf(3)) + Inbuf(4)*256					
						value = General.ToUnsigned(Inbuf(5)) + Inbuf(6)*256
						ffbyte= Inbuf(3) + Inbuf(5) + Inbuf(4)+ Inbuf(6)
						If ffbyte = Inbuf(7) Then			''if the last value of the received string is the cum of the other values 
					VariabelenVullenWord(value,Ident)		'' the values are oke and can be used.
							inbufact = 0
						For i = 0 To Inbuf.Length-1
								Inbuf(i) = 0
							Next
						End If
				End If
			End If
		End If
	End If

	If inbufact>6 Then inbufact = 0 
	Return 1
End Sub

Sub VariabelenVullenWord(vulWaarde As Int,vulIdent As Int)

Select Case vulIdent
		Case 967
			Dim tempbyte As Byte = vulWaarde
			General.APPO(0) = General.ToUnsigned(tempbyte)	
		Case  978
			Dim tempbyte As Byte = vulWaarde	''tempbyte = result(1)
			General.APPO(1) = General.ToUnsigned(tempbyte)			
		Case  990
			General.OVW0(0) = vulWaarde
		Case 994
			General.OVW1(0) = vulWaarde
		Case  998
			General.OVW2(0) =vulWaarde
		Case  1002
			General.OVW3(0) = vulWaarde
		Case  1006
			General.OVW4(0) =vulWaarde
		Case  992
			General.OVW0(1) = vulWaarde
		Case  996
			General.OVW1(1) = vulWaarde
		Case  1000
			General.OVW2(1) =vulWaarde
		Case  1004
			General.OVW3(1) = vulWaarde
		Case  1008
			General.OVW4(1) =vulWaarde
	Case Else
End Select	
End Sub

Private Sub Wifiastream_Error
	Log("Disconnected")
	Wificonnected = False
	Wifiwatchdog.Enabled = False
End Sub

Private Sub Wifiastream_Terminated
	Wifiastream_Error
End Sub

Private Sub Watchdog_Tick
	If DateTime.Now - WifilastValueTime > 100 * DateTime.TicksPerSecond Then
		Log("Watchdog closing connection.")
		If Wifiastream.IsInitialized Then Wifiastream.Close
		Wifiastream_Error
	End If
End Sub

Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub



